# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'JobDestinationDbArgs',
    'JobLimitSpeedArgs',
    'JobSourceDbArgs',
]

@pulumi.input_type
class JobDestinationDbArgs:
    def __init__(__self__, *,
                 engine_type: pulumi.Input[str],
                 ip: pulumi.Input[str],
                 password: pulumi.Input[str],
                 port: pulumi.Input[int],
                 user: pulumi.Input[str],
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 ssl_cert_check_sum: Optional[pulumi.Input[str]] = None,
                 ssl_cert_key: Optional[pulumi.Input[str]] = None,
                 ssl_cert_name: Optional[pulumi.Input[str]] = None,
                 ssl_cert_password: Optional[pulumi.Input[str]] = None,
                 ssl_enabled: Optional[pulumi.Input[bool]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] engine_type: Specifies the engine type of database. Changing this parameter will
               create a new resource. The options are as follows: `mysql`, `mongodb`, `gaussdbv5`.
        :param pulumi.Input[str] ip: Specifies the IP of database. Changing this parameter will create a new resource.
        :param pulumi.Input[str] password: Specifies the password of database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[int] port: Specifies the port of database. Changing this parameter will create a new resource.
        :param pulumi.Input[str] user: Specifies the user name of database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] instance_id: Specifies the instance id of database when it is a RDS database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] name: Specifies the name of database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] region: Specifies the region which the database belongs when it is a RDS database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_check_sum: Specifies the checksum of SSL certificate content.
               It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_key: Specifies the SSL certificate content, encrypted with base64.
               It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_name: Specifies SSL certificate name.
               It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_password: Specifies SSL certificate password. It is mandatory when
               `ssl_enabled` is `true` and the certificate file suffix is `.p12`. Changing this parameter will create a new resource.
        :param pulumi.Input[bool] ssl_enabled: Specifies whether to enable SSL connection.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] subnet_id: Specifies subnet ID of database when it is a RDS database.
               It is mandatory when `direction` is `down`. Changing this parameter will create a new resource.
        """
        pulumi.set(__self__, "engine_type", engine_type)
        pulumi.set(__self__, "ip", ip)
        pulumi.set(__self__, "password", password)
        pulumi.set(__self__, "port", port)
        pulumi.set(__self__, "user", user)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if ssl_cert_check_sum is not None:
            pulumi.set(__self__, "ssl_cert_check_sum", ssl_cert_check_sum)
        if ssl_cert_key is not None:
            pulumi.set(__self__, "ssl_cert_key", ssl_cert_key)
        if ssl_cert_name is not None:
            pulumi.set(__self__, "ssl_cert_name", ssl_cert_name)
        if ssl_cert_password is not None:
            pulumi.set(__self__, "ssl_cert_password", ssl_cert_password)
        if ssl_enabled is not None:
            pulumi.set(__self__, "ssl_enabled", ssl_enabled)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)

    @property
    @pulumi.getter(name="engineType")
    def engine_type(self) -> pulumi.Input[str]:
        """
        Specifies the engine type of database. Changing this parameter will
        create a new resource. The options are as follows: `mysql`, `mongodb`, `gaussdbv5`.
        """
        return pulumi.get(self, "engine_type")

    @engine_type.setter
    def engine_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "engine_type", value)

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Input[str]:
        """
        Specifies the IP of database. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def password(self) -> pulumi.Input[str]:
        """
        Specifies the password of database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: pulumi.Input[str]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def port(self) -> pulumi.Input[int]:
        """
        Specifies the port of database. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: pulumi.Input[int]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter
    def user(self) -> pulumi.Input[str]:
        """
        Specifies the user name of database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "user")

    @user.setter
    def user(self, value: pulumi.Input[str]):
        pulumi.set(self, "user", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the instance id of database when it is a RDS database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region which the database belongs when it is a RDS database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="sslCertCheckSum")
    def ssl_cert_check_sum(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the checksum of SSL certificate content.
        It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_check_sum")

    @ssl_cert_check_sum.setter
    def ssl_cert_check_sum(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_check_sum", value)

    @property
    @pulumi.getter(name="sslCertKey")
    def ssl_cert_key(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SSL certificate content, encrypted with base64.
        It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_key")

    @ssl_cert_key.setter
    def ssl_cert_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_key", value)

    @property
    @pulumi.getter(name="sslCertName")
    def ssl_cert_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies SSL certificate name.
        It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_name")

    @ssl_cert_name.setter
    def ssl_cert_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_name", value)

    @property
    @pulumi.getter(name="sslCertPassword")
    def ssl_cert_password(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies SSL certificate password. It is mandatory when
        `ssl_enabled` is `true` and the certificate file suffix is `.p12`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_password")

    @ssl_cert_password.setter
    def ssl_cert_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_password", value)

    @property
    @pulumi.getter(name="sslEnabled")
    def ssl_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to enable SSL connection.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_enabled")

    @ssl_enabled.setter
    def ssl_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ssl_enabled", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies subnet ID of database when it is a RDS database.
        It is mandatory when `direction` is `down`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)


@pulumi.input_type
class JobLimitSpeedArgs:
    def __init__(__self__, *,
                 end_time: pulumi.Input[str],
                 speed: pulumi.Input[str],
                 start_time: pulumi.Input[str]):
        """
        :param pulumi.Input[str] end_time: Specifies the time to end speed limit, this time is UTC time. The input must
               end at 59 minutes, the format is `hh:mm`, for example: 15:59. Changing this parameter will create a new resource.
        :param pulumi.Input[str] speed: Specifies the transmission speed, the value range is 1 to 9999, unit: `MB/s`.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] start_time: Specifies the time to start speed limit, this time is UTC time. The start
               time is the whole hour, if there is a minute, it will be ignored, the format is `hh:mm`, and the hour number
               is two digits, for example: 01:00. Changing this parameter will create a new resource.
        """
        pulumi.set(__self__, "end_time", end_time)
        pulumi.set(__self__, "speed", speed)
        pulumi.set(__self__, "start_time", start_time)

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> pulumi.Input[str]:
        """
        Specifies the time to end speed limit, this time is UTC time. The input must
        end at 59 minutes, the format is `hh:mm`, for example: 15:59. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "end_time")

    @end_time.setter
    def end_time(self, value: pulumi.Input[str]):
        pulumi.set(self, "end_time", value)

    @property
    @pulumi.getter
    def speed(self) -> pulumi.Input[str]:
        """
        Specifies the transmission speed, the value range is 1 to 9999, unit: `MB/s`.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "speed")

    @speed.setter
    def speed(self, value: pulumi.Input[str]):
        pulumi.set(self, "speed", value)

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> pulumi.Input[str]:
        """
        Specifies the time to start speed limit, this time is UTC time. The start
        time is the whole hour, if there is a minute, it will be ignored, the format is `hh:mm`, and the hour number
        is two digits, for example: 01:00. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "start_time")

    @start_time.setter
    def start_time(self, value: pulumi.Input[str]):
        pulumi.set(self, "start_time", value)


@pulumi.input_type
class JobSourceDbArgs:
    def __init__(__self__, *,
                 engine_type: pulumi.Input[str],
                 ip: pulumi.Input[str],
                 password: pulumi.Input[str],
                 port: pulumi.Input[int],
                 user: pulumi.Input[str],
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 ssl_cert_check_sum: Optional[pulumi.Input[str]] = None,
                 ssl_cert_key: Optional[pulumi.Input[str]] = None,
                 ssl_cert_name: Optional[pulumi.Input[str]] = None,
                 ssl_cert_password: Optional[pulumi.Input[str]] = None,
                 ssl_enabled: Optional[pulumi.Input[bool]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] engine_type: Specifies the engine type of database. Changing this parameter will
               create a new resource. The options are as follows: `mysql`, `mongodb`, `gaussdbv5`.
        :param pulumi.Input[str] ip: Specifies the IP of database. Changing this parameter will create a new resource.
        :param pulumi.Input[str] password: Specifies the password of database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[int] port: Specifies the port of database. Changing this parameter will create a new resource.
        :param pulumi.Input[str] user: Specifies the user name of database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] instance_id: Specifies the instance id of database when it is a RDS database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] name: Specifies the name of database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] region: Specifies the region which the database belongs when it is a RDS database.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_check_sum: Specifies the checksum of SSL certificate content.
               It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_key: Specifies the SSL certificate content, encrypted with base64.
               It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_name: Specifies SSL certificate name.
               It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        :param pulumi.Input[str] ssl_cert_password: Specifies SSL certificate password. It is mandatory when
               `ssl_enabled` is `true` and the certificate file suffix is `.p12`. Changing this parameter will create a new resource.
        :param pulumi.Input[bool] ssl_enabled: Specifies whether to enable SSL connection.
               Changing this parameter will create a new resource.
        :param pulumi.Input[str] subnet_id: Specifies subnet ID of database when it is a RDS database.
               It is mandatory when `direction` is `down`. Changing this parameter will create a new resource.
        """
        pulumi.set(__self__, "engine_type", engine_type)
        pulumi.set(__self__, "ip", ip)
        pulumi.set(__self__, "password", password)
        pulumi.set(__self__, "port", port)
        pulumi.set(__self__, "user", user)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if ssl_cert_check_sum is not None:
            pulumi.set(__self__, "ssl_cert_check_sum", ssl_cert_check_sum)
        if ssl_cert_key is not None:
            pulumi.set(__self__, "ssl_cert_key", ssl_cert_key)
        if ssl_cert_name is not None:
            pulumi.set(__self__, "ssl_cert_name", ssl_cert_name)
        if ssl_cert_password is not None:
            pulumi.set(__self__, "ssl_cert_password", ssl_cert_password)
        if ssl_enabled is not None:
            pulumi.set(__self__, "ssl_enabled", ssl_enabled)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)

    @property
    @pulumi.getter(name="engineType")
    def engine_type(self) -> pulumi.Input[str]:
        """
        Specifies the engine type of database. Changing this parameter will
        create a new resource. The options are as follows: `mysql`, `mongodb`, `gaussdbv5`.
        """
        return pulumi.get(self, "engine_type")

    @engine_type.setter
    def engine_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "engine_type", value)

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Input[str]:
        """
        Specifies the IP of database. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def password(self) -> pulumi.Input[str]:
        """
        Specifies the password of database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: pulumi.Input[str]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def port(self) -> pulumi.Input[int]:
        """
        Specifies the port of database. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: pulumi.Input[int]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter
    def user(self) -> pulumi.Input[str]:
        """
        Specifies the user name of database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "user")

    @user.setter
    def user(self, value: pulumi.Input[str]):
        pulumi.set(self, "user", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the instance id of database when it is a RDS database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region which the database belongs when it is a RDS database.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="sslCertCheckSum")
    def ssl_cert_check_sum(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the checksum of SSL certificate content.
        It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_check_sum")

    @ssl_cert_check_sum.setter
    def ssl_cert_check_sum(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_check_sum", value)

    @property
    @pulumi.getter(name="sslCertKey")
    def ssl_cert_key(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SSL certificate content, encrypted with base64.
        It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_key")

    @ssl_cert_key.setter
    def ssl_cert_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_key", value)

    @property
    @pulumi.getter(name="sslCertName")
    def ssl_cert_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies SSL certificate name.
        It is mandatory when `ssl_enabled` is `true`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_name")

    @ssl_cert_name.setter
    def ssl_cert_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_name", value)

    @property
    @pulumi.getter(name="sslCertPassword")
    def ssl_cert_password(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies SSL certificate password. It is mandatory when
        `ssl_enabled` is `true` and the certificate file suffix is `.p12`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_cert_password")

    @ssl_cert_password.setter
    def ssl_cert_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_cert_password", value)

    @property
    @pulumi.getter(name="sslEnabled")
    def ssl_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to enable SSL connection.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "ssl_enabled")

    @ssl_enabled.setter
    def ssl_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ssl_enabled", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies subnet ID of database when it is a RDS database.
        It is mandatory when `direction` is `down`. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)


